#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_dJIK6x3x48TN6x3x1_a1_b0
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=6, NB=3, KB=48, 
 * lda=0, ldb=0, ldc=0, mu=6, nu=3, ku=1, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   const double *stM = A + (((lda) << 2)+((lda) << 1));
   const double *stN = B + (((ldb) << 1)+ldb);
   const double *pfA = A + M;
   #define incAk 1
   const int incAm = ((((lda) << 2)+((lda) << 1)) - 48), incAn = -(((lda) << 2)+((lda) << 1));
   #define incBk 1
   const int incBm = -48, incBn = (((ldb) << 1)+ldb);
   #define incCm 6
   const int incCn = (((ldc) << 1)+ldc) - 6;
   double *pC0=C, *pC1=pC0+(ldc), *pC2=pC1+(ldc);
   const double *pA0=A, *pA1=pA0+(lda), *pA2=pA1+(lda), *pA3=pA2+(lda), *pA4=pA3+(lda), *pA5=pA4+(lda);
   const double *pB0=B, *pB1=pB0+(ldb), *pB2=pB1+(ldb);
   register int k;
   register double rA0, rA1, rA2, rA3, rA4, rA5;
   register double rB0, rB1, rB2;
   register double rC0_0, rC1_0, rC2_0, rC3_0, rC4_0, rC5_0, rC0_1, rC1_1, rC2_1, rC3_1, rC4_1, rC5_1, rC0_2, rC1_2, rC2_2, rC3_2, rC4_2, rC5_2;
/*
 * Feeble prefetch of C
 */
   rC0_0 = *pC0;
   rC0_1 = *pC1;
   rC0_2 = *pC2;
   ATL_pfl1W(pC0);
   ATL_pfl1W(pC1);
   ATL_pfl1W(pC2);
/*
 * Peel 1st iter to assign C regs
 */
   rA0 = *pA0;
   rB0 = *pB0;
   rA1 = *pA1;
   rA2 = *pA2;
   rA3 = *pA3;
   rA4 = *pA4;
   rC0_0 = rA0 * rB0;
   rA5 = *pA5;
   rB1 = *pB1;
   rB2 = *pB2;
   rC1_0 = rA1 * rB0;
   rC2_0 = rA2 * rB0;
   rC3_0 = rA3 * rB0;
   rC4_0 = rA4 * rB0;
   rC5_0 = rA5 * rB0;
   rC0_1 = rA0 * rB1;
   rC1_1 = rA1 * rB1;
   rC2_1 = rA2 * rB1;
   rC3_1 = rA3 * rB1;
   rC4_1 = rA4 * rB1;
   rC5_1 = rA5 * rB1;
   rC0_2 = rA0 * rB2;
   rC1_2 = rA1 * rB2;
   rC2_2 = rA2 * rB2;
   rC3_2 = rA3 * rB2;
   rC4_2 = rA4 * rB2;
   rC5_2 = rA5 * rB2;
   pA0 += incAk;
   pA1 += incAk;
   pA2 += incAk;
   pA3 += incAk;
   pA4 += incAk;
   pA5 += incAk;
   pB0 += incBk;
   pB1 += incBk;
   pB2 += incBk;
/*
 * Unpeeled K iterations
 */
   for (k=47; k; k--) /* easy loop to unroll */
   {
      rA0 = *pA0;
      rB0 = *pB0;
      rA1 = *pA1;
      rA2 = *pA2;
      rA3 = *pA3;
      rA4 = *pA4;
      rC0_0 += rA0 * rB0;
      rA5 = *pA5;
      rB1 = *pB1;
      rB2 = *pB2;
      rC1_0 += rA1 * rB0;
      rC2_0 += rA2 * rB0;
      rC3_0 += rA3 * rB0;
      rC4_0 += rA4 * rB0;
      rC5_0 += rA5 * rB0;
      rC0_1 += rA0 * rB1;
      rC1_1 += rA1 * rB1;
      rC2_1 += rA2 * rB1;
      rC3_1 += rA3 * rB1;
      rC4_1 += rA4 * rB1;
      rC5_1 += rA5 * rB1;
      rC0_2 += rA0 * rB2;
      rC1_2 += rA1 * rB2;
      rC2_2 += rA2 * rB2;
      rC3_2 += rA3 * rB2;
      rC4_2 += rA4 * rB2;
      rC5_2 += rA5 * rB2;
      pA0 += incAk;
      pA1 += incAk;
      pA2 += incAk;
      pA3 += incAk;
      pA4 += incAk;
      pA5 += incAk;
      pB0 += incBk;
      pB1 += incBk;
      pB2 += incBk;
   }
   *pC0 = rC0_0;
   pC0[1] = rC1_0;
   pC0[2] = rC2_0;
   pC0[3] = rC3_0;
   pC0[4] = rC4_0;
   pC0[5] = rC5_0;
   *pC1 = rC0_1;
   pC1[1] = rC1_1;
   pC1[2] = rC2_1;
   pC1[3] = rC3_1;
   pC1[4] = rC4_1;
   pC1[5] = rC5_1;
   *pC2 = rC0_2;
   pC2[1] = rC1_2;
   pC2[2] = rC2_2;
   pC2[3] = rC3_2;
   pC2[4] = rC4_2;
   pC2[5] = rC5_2;
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
static void ATL_dJIK48x3x48TN7x3x1_a1_b0
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=48, NB=3, KB=48, 
 * lda=0, ldb=0, ldc=0, mu=7, nu=3, ku=1, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   const double *ca=A, *cb=B;
   double *cc=C;
   const double *stM = A + (42*(lda));
   const double *stN = B + (((ldb) << 1)+ldb);
   const double *pfA = A + M;
   #define incAk 1
   const int incAm = ((7*(lda)) - 48), incAn = -(42*(lda));
   #define incBk 1
   const int incBm = -48, incBn = (((ldb) << 1)+ldb);
   #define incCm 7
   const int incCn = (((ldc) << 1)+ldc) - 42;
   double *pC0=C, *pC1=pC0+(ldc), *pC2=pC1+(ldc);
   const double *pA0=A, *pA1=pA0+(lda), *pA2=pA1+(lda), *pA3=pA2+(lda), *pA4=pA3+(lda), *pA5=pA4+(lda), *pA6=pA5+(lda);
   const double *pB0=B, *pB1=pB0+(ldb), *pB2=pB1+(ldb);
   register int k;
   register double rA0, rA1, rA2, rA3, rA4, rA5, rA6;
   register double rB0, rB1, rB2;
   register double rC0_0, rC1_0, rC2_0, rC3_0, rC4_0, rC5_0, rC6_0, rC0_1, rC1_1, rC2_1, rC3_1, rC4_1, rC5_1, rC6_1, rC0_2, rC1_2, rC2_2, rC3_2, rC4_2, rC5_2, rC6_2;
   do /* M-loop */
   {
/*
 *    Feeble prefetch of C
 */
      rC0_0 = *pC0;
      rC0_1 = *pC1;
      rC0_2 = *pC2;
      ATL_pfl1W(pC0);
      ATL_pfl1W(pC1);
      ATL_pfl1W(pC2);
/*
 *    Peel 1st iter to assign C regs
 */
      rA0 = *pA0;
      rB0 = *pB0;
      rA1 = *pA1;
      rA2 = *pA2;
      rA3 = *pA3;
      rA4 = *pA4;
      rC0_0 = rA0 * rB0;
      rA5 = *pA5;
      rA6 = *pA6;
      rB1 = *pB1;
      rC1_0 = rA1 * rB0;
      rB2 = *pB2;
      rC2_0 = rA2 * rB0;
      rC3_0 = rA3 * rB0;
      rC4_0 = rA4 * rB0;
      rC5_0 = rA5 * rB0;
      rC6_0 = rA6 * rB0;
      rC0_1 = rA0 * rB1;
      rC1_1 = rA1 * rB1;
      rC2_1 = rA2 * rB1;
      rC3_1 = rA3 * rB1;
      rC4_1 = rA4 * rB1;
      rC5_1 = rA5 * rB1;
      rC6_1 = rA6 * rB1;
      rC0_2 = rA0 * rB2;
      rC1_2 = rA1 * rB2;
      rC2_2 = rA2 * rB2;
      rC3_2 = rA3 * rB2;
      rC4_2 = rA4 * rB2;
      rC5_2 = rA5 * rB2;
      rC6_2 = rA6 * rB2;
      pA0 += incAk;
      pA1 += incAk;
      pA2 += incAk;
      pA3 += incAk;
      pA4 += incAk;
      pA5 += incAk;
      pA6 += incAk;
      pB0 += incBk;
      pB1 += incBk;
      pB2 += incBk;
/*
 *    Unpeeled K iterations
 */
      for (k=47; k; k--) /* easy loop to unroll */
      {
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = *pA1;
         rA2 = *pA2;
         rA3 = *pA3;
         rA4 = *pA4;
         rC0_0 += rA0 * rB0;
         rA5 = *pA5;
         rA6 = *pA6;
         rB1 = *pB1;
         rC1_0 += rA1 * rB0;
         rB2 = *pB2;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         rC6_0 += rA6 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC5_1 += rA5 * rB1;
         rC6_1 += rA6 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC5_2 += rA5 * rB2;
         rC6_2 += rA6 * rB2;
         pA0 += incAk;
         pA1 += incAk;
         pA2 += incAk;
         pA3 += incAk;
         pA4 += incAk;
         pA5 += incAk;
         pA6 += incAk;
         pB0 += incBk;
         pB1 += incBk;
         pB2 += incBk;
      }
      *pC0 = rC0_0;
      pC0[1] = rC1_0;
      pC0[2] = rC2_0;
      pC0[3] = rC3_0;
      pC0[4] = rC4_0;
      pC0[5] = rC5_0;
      pC0[6] = rC6_0;
      *pC1 = rC0_1;
      pC1[1] = rC1_1;
      pC1[2] = rC2_1;
      pC1[3] = rC3_1;
      pC1[4] = rC4_1;
      pC1[5] = rC5_1;
      pC1[6] = rC6_1;
      *pC2 = rC0_2;
      pC2[1] = rC1_2;
      pC2[2] = rC2_2;
      pC2[3] = rC3_2;
      pC2[4] = rC4_2;
      pC2[5] = rC5_2;
      pC2[6] = rC6_2;
      pC0 += incCm;
      pC1 += incCm;
      pC2 += incCm;
      pA0 += incAm;
      pA1 += incAm;
      pA2 += incAm;
      pA3 += incAm;
      pA4 += incAm;
      pA5 += incAm;
      pA6 += incAm;
      pB0 += incBm;
      pB1 += incBm;
      pB2 += incBm;
   }
   while(pA0 != stM);
   ATL_dJIK6x3x48TN6x3x1_a1_b0(6, 3, 48, alpha, ca + (42*(lda)), lda, cb, ldb, beta, cc + 42, ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_dJIK6x45x48TN6x5x1_a1_b0
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=6, NB=45, KB=48, 
 * lda=0, ldb=0, ldc=0, mu=6, nu=5, ku=1, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   const double *stM = A + (((lda) << 2)+((lda) << 1));
   const double *stN = B + (45*(ldb));
   const double *pfA = A + M;
   #define incAk 1
   const int incAm = ((((lda) << 2)+((lda) << 1)) - 48), incAn = -(((lda) << 2)+((lda) << 1));
   #define incBk 1
   const int incBm = -48, incBn = (((ldb) << 2)+ldb);
   #define incCm 6
   const int incCn = (((ldc) << 2)+ldc) - 6;
   double *pC0=C, *pC1=pC0+(ldc), *pC2=pC1+(ldc), *pC3=pC2+(ldc), *pC4=pC3+(ldc);
   const double *pA0=A, *pA1=pA0+(lda), *pA2=pA1+(lda), *pA3=pA2+(lda), *pA4=pA3+(lda), *pA5=pA4+(lda);
   const double *pB0=B, *pB1=pB0+(ldb), *pB2=pB1+(ldb), *pB3=pB2+(ldb), *pB4=pB3+(ldb);
   register int k;
   register double rA0, rA1, rA2, rA3, rA4, rA5;
   register double rB0, rB1, rB2, rB3, rB4;
   register double rC0_0, rC1_0, rC2_0, rC3_0, rC4_0, rC5_0, rC0_1, rC1_1, rC2_1, rC3_1, rC4_1, rC5_1, rC0_2, rC1_2, rC2_2, rC3_2, rC4_2, rC5_2, rC0_3, rC1_3, rC2_3, rC3_3, rC4_3, rC5_3, rC0_4, rC1_4, rC2_4, rC3_4, rC4_4, rC5_4;
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      ATL_pfl1R(pfA+8);
      ATL_pfl1R(pfA+16);
      ATL_pfl1R(pfA+24);
      ATL_pfl1R(pfA+32);
      ATL_pfl1R(pfA+40);
      pfA += lda;
/*
 *    Feeble prefetch of C
 */
      rC0_0 = *pC0;
      rC0_1 = *pC1;
      rC0_2 = *pC2;
      rC0_3 = *pC3;
      rC0_4 = *pC4;
      ATL_pfl1W(pC0);
      ATL_pfl1W(pC1);
      ATL_pfl1W(pC2);
      ATL_pfl1W(pC3);
      ATL_pfl1W(pC4);
/*
 *    Peel 1st iter to assign C regs
 */
      rA0 = *pA0;
      rB0 = *pB0;
      rA1 = *pA1;
      rA2 = *pA2;
      rA3 = *pA3;
      rA4 = *pA4;
      rC0_0 = rA0 * rB0;
      rA5 = *pA5;
      rB1 = *pB1;
      rB2 = *pB2;
      rC1_0 = rA1 * rB0;
      rB3 = *pB3;
      rB4 = *pB4;
      rC2_0 = rA2 * rB0;
      rC3_0 = rA3 * rB0;
      rC4_0 = rA4 * rB0;
      rC5_0 = rA5 * rB0;
      rC0_1 = rA0 * rB1;
      rC1_1 = rA1 * rB1;
      rC2_1 = rA2 * rB1;
      rC3_1 = rA3 * rB1;
      rC4_1 = rA4 * rB1;
      rC5_1 = rA5 * rB1;
      rC0_2 = rA0 * rB2;
      rC1_2 = rA1 * rB2;
      rC2_2 = rA2 * rB2;
      rC3_2 = rA3 * rB2;
      rC4_2 = rA4 * rB2;
      rC5_2 = rA5 * rB2;
      rC0_3 = rA0 * rB3;
      rC1_3 = rA1 * rB3;
      rC2_3 = rA2 * rB3;
      rC3_3 = rA3 * rB3;
      rC4_3 = rA4 * rB3;
      rC5_3 = rA5 * rB3;
      rC0_4 = rA0 * rB4;
      rC1_4 = rA1 * rB4;
      rC2_4 = rA2 * rB4;
      rC3_4 = rA3 * rB4;
      rC4_4 = rA4 * rB4;
      rC5_4 = rA5 * rB4;
      pA0 += incAk;
      pA1 += incAk;
      pA2 += incAk;
      pA3 += incAk;
      pA4 += incAk;
      pA5 += incAk;
      pB0 += incBk;
      pB1 += incBk;
      pB2 += incBk;
      pB3 += incBk;
      pB4 += incBk;
/*
 *    Unpeeled K iterations
 */
      for (k=47; k; k--) /* easy loop to unroll */
      {
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = *pA1;
         rA2 = *pA2;
         rA3 = *pA3;
         rA4 = *pA4;
         rC0_0 += rA0 * rB0;
         rA5 = *pA5;
         rB1 = *pB1;
         rB2 = *pB2;
         rC1_0 += rA1 * rB0;
         rB3 = *pB3;
         rB4 = *pB4;
         rC2_0 += rA2 * rB0;
         rC3_0 += rA3 * rB0;
         rC4_0 += rA4 * rB0;
         rC5_0 += rA5 * rB0;
         rC0_1 += rA0 * rB1;
         rC1_1 += rA1 * rB1;
         rC2_1 += rA2 * rB1;
         rC3_1 += rA3 * rB1;
         rC4_1 += rA4 * rB1;
         rC5_1 += rA5 * rB1;
         rC0_2 += rA0 * rB2;
         rC1_2 += rA1 * rB2;
         rC2_2 += rA2 * rB2;
         rC3_2 += rA3 * rB2;
         rC4_2 += rA4 * rB2;
         rC5_2 += rA5 * rB2;
         rC0_3 += rA0 * rB3;
         rC1_3 += rA1 * rB3;
         rC2_3 += rA2 * rB3;
         rC3_3 += rA3 * rB3;
         rC4_3 += rA4 * rB3;
         rC5_3 += rA5 * rB3;
         rC0_4 += rA0 * rB4;
         rC1_4 += rA1 * rB4;
         rC2_4 += rA2 * rB4;
         rC3_4 += rA3 * rB4;
         rC4_4 += rA4 * rB4;
         rC5_4 += rA5 * rB4;
         pA0 += incAk;
         pA1 += incAk;
         pA2 += incAk;
         pA3 += incAk;
         pA4 += incAk;
         pA5 += incAk;
         pB0 += incBk;
         pB1 += incBk;
         pB2 += incBk;
         pB3 += incBk;
         pB4 += incBk;
      }
      *pC0 = rC0_0;
      pC0[1] = rC1_0;
      pC0[2] = rC2_0;
      pC0[3] = rC3_0;
      pC0[4] = rC4_0;
      pC0[5] = rC5_0;
      *pC1 = rC0_1;
      pC1[1] = rC1_1;
      pC1[2] = rC2_1;
      pC1[3] = rC3_1;
      pC1[4] = rC4_1;
      pC1[5] = rC5_1;
      *pC2 = rC0_2;
      pC2[1] = rC1_2;
      pC2[2] = rC2_2;
      pC2[3] = rC3_2;
      pC2[4] = rC4_2;
      pC2[5] = rC5_2;
      *pC3 = rC0_3;
      pC3[1] = rC1_3;
      pC3[2] = rC2_3;
      pC3[3] = rC3_3;
      pC3[4] = rC4_3;
      pC3[5] = rC5_3;
      *pC4 = rC0_4;
      pC4[1] = rC1_4;
      pC4[2] = rC2_4;
      pC4[3] = rC3_4;
      pC4[4] = rC4_4;
      pC4[5] = rC5_4;
      pC0 += incCm;
      pC1 += incCm;
      pC2 += incCm;
      pC3 += incCm;
      pC4 += incCm;
      pA0 += incAm;
      pA1 += incAm;
      pA2 += incAm;
      pA3 += incAm;
      pA4 += incAm;
      pA5 += incAm;
      pB0 += incBm;
      pB1 += incBm;
      pB2 += incBm;
      pB3 += incBm;
      pB4 += incBm;
      pC0 += incCn;
      pC1 += incCn;
      pC2 += incCn;
      pC3 += incCn;
      pC4 += incCn;
      pA0 += incAn;
      pA1 += incAn;
      pA2 += incAn;
      pA3 += incAn;
      pA4 += incAn;
      pA5 += incAn;
      pB0 += incBn;
      pB1 += incBn;
      pB2 += incBn;
      pB3 += incBn;
      pB4 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
void ATL_dJIK48x48x48TN0x0x0_a1_b0
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=48, NB=48, KB=48, 
 * lda=0, ldb=0, ldc=0, mu=7, nu=5, ku=1, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   const double *ca=A, *cb=B;
   double *cc=C;
   const double *stM = A + (42*(lda));
   const double *stN = B + (45*(ldb));
   const double *pfA = A + M;
   #define incAk 1
   const int incAm = ((7*(lda)) - 48), incAn = -(42*(lda));
   #define incBk 1
   const int incBm = -48, incBn = (((ldb) << 2)+ldb);
   #define incCm 7
   const int incCn = (((ldc) << 2)+ldc) - 42;
   double *pC0=C, *pC1=pC0+(ldc), *pC2=pC1+(ldc), *pC3=pC2+(ldc), *pC4=pC3+(ldc);
   const double *pA0=A, *pA1=pA0+(lda), *pA2=pA1+(lda), *pA3=pA2+(lda), *pA4=pA3+(lda), *pA5=pA4+(lda), *pA6=pA5+(lda);
   const double *pB0=B, *pB1=pB0+(ldb), *pB2=pB1+(ldb), *pB3=pB2+(ldb), *pB4=pB3+(ldb);
   register int k;
   register double rA0, rA1, rA2, rA3, rA4, rA5, rA6;
   register double rB0, rB1, rB2, rB3, rB4;
   register double rC0_0, rC1_0, rC2_0, rC3_0, rC4_0, rC5_0, rC6_0, rC0_1, rC1_1, rC2_1, rC3_1, rC4_1, rC5_1, rC6_1, rC0_2, rC1_2, rC2_2, rC3_2, rC4_2, rC5_2, rC6_2, rC0_3, rC1_3, rC2_3, rC3_3, rC4_3, rC5_3, rC6_3, rC0_4, rC1_4, rC2_4, rC3_4, rC4_4, rC5_4, rC6_4;
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      ATL_pfl1R(pfA+8);
      ATL_pfl1R(pfA+16);
      ATL_pfl1R(pfA+24);
      ATL_pfl1R(pfA+32);
      ATL_pfl1R(pfA+40);
      pfA += lda;
      do /* M-loop */
      {
/*
 *       Feeble prefetch of C
 */
         rC0_0 = *pC0;
         rC0_1 = *pC1;
         rC0_2 = *pC2;
         rC0_3 = *pC3;
         rC0_4 = *pC4;
         ATL_pfl1W(pC0);
         ATL_pfl1W(pC1);
         ATL_pfl1W(pC2);
         ATL_pfl1W(pC3);
         ATL_pfl1W(pC4);
/*
 *       Peel 1st iter to assign C regs
 */
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = *pA1;
         rA2 = *pA2;
         rA3 = *pA3;
         rA4 = *pA4;
         rC0_0 = rA0 * rB0;
         rA5 = *pA5;
         rA6 = *pA6;
         rB1 = *pB1;
         rC1_0 = rA1 * rB0;
         rB2 = *pB2;
         rB3 = *pB3;
         rB4 = *pB4;
         rC2_0 = rA2 * rB0;
         rC3_0 = rA3 * rB0;
         rC4_0 = rA4 * rB0;
         rC5_0 = rA5 * rB0;
         rC6_0 = rA6 * rB0;
         rC0_1 = rA0 * rB1;
         rC1_1 = rA1 * rB1;
         rC2_1 = rA2 * rB1;
         rC3_1 = rA3 * rB1;
         rC4_1 = rA4 * rB1;
         rC5_1 = rA5 * rB1;
         rC6_1 = rA6 * rB1;
         rC0_2 = rA0 * rB2;
         rC1_2 = rA1 * rB2;
         rC2_2 = rA2 * rB2;
         rC3_2 = rA3 * rB2;
         rC4_2 = rA4 * rB2;
         rC5_2 = rA5 * rB2;
         rC6_2 = rA6 * rB2;
         rC0_3 = rA0 * rB3;
         rC1_3 = rA1 * rB3;
         rC2_3 = rA2 * rB3;
         rC3_3 = rA3 * rB3;
         rC4_3 = rA4 * rB3;
         rC5_3 = rA5 * rB3;
         rC6_3 = rA6 * rB3;
         rC0_4 = rA0 * rB4;
         rC1_4 = rA1 * rB4;
         rC2_4 = rA2 * rB4;
         rC3_4 = rA3 * rB4;
         rC4_4 = rA4 * rB4;
         rC5_4 = rA5 * rB4;
         rC6_4 = rA6 * rB4;
         pA0 += incAk;
         pA1 += incAk;
         pA2 += incAk;
         pA3 += incAk;
         pA4 += incAk;
         pA5 += incAk;
         pA6 += incAk;
         pB0 += incBk;
         pB1 += incBk;
         pB2 += incBk;
         pB3 += incBk;
         pB4 += incBk;
/*
 *       Unpeeled K iterations
 */
         for (k=47; k; k--) /* easy loop to unroll */
         {
            rA0 = *pA0;
            rB0 = *pB0;
            rA1 = *pA1;
            rA2 = *pA2;
            rA3 = *pA3;
            rA4 = *pA4;
            rC0_0 += rA0 * rB0;
            rA5 = *pA5;
            rA6 = *pA6;
            rB1 = *pB1;
            rC1_0 += rA1 * rB0;
            rB2 = *pB2;
            rB3 = *pB3;
            rB4 = *pB4;
            rC2_0 += rA2 * rB0;
            rC3_0 += rA3 * rB0;
            rC4_0 += rA4 * rB0;
            rC5_0 += rA5 * rB0;
            rC6_0 += rA6 * rB0;
            rC0_1 += rA0 * rB1;
            rC1_1 += rA1 * rB1;
            rC2_1 += rA2 * rB1;
            rC3_1 += rA3 * rB1;
            rC4_1 += rA4 * rB1;
            rC5_1 += rA5 * rB1;
            rC6_1 += rA6 * rB1;
            rC0_2 += rA0 * rB2;
            rC1_2 += rA1 * rB2;
            rC2_2 += rA2 * rB2;
            rC3_2 += rA3 * rB2;
            rC4_2 += rA4 * rB2;
            rC5_2 += rA5 * rB2;
            rC6_2 += rA6 * rB2;
            rC0_3 += rA0 * rB3;
            rC1_3 += rA1 * rB3;
            rC2_3 += rA2 * rB3;
            rC3_3 += rA3 * rB3;
            rC4_3 += rA4 * rB3;
            rC5_3 += rA5 * rB3;
            rC6_3 += rA6 * rB3;
            rC0_4 += rA0 * rB4;
            rC1_4 += rA1 * rB4;
            rC2_4 += rA2 * rB4;
            rC3_4 += rA3 * rB4;
            rC4_4 += rA4 * rB4;
            rC5_4 += rA5 * rB4;
            rC6_4 += rA6 * rB4;
            pA0 += incAk;
            pA1 += incAk;
            pA2 += incAk;
            pA3 += incAk;
            pA4 += incAk;
            pA5 += incAk;
            pA6 += incAk;
            pB0 += incBk;
            pB1 += incBk;
            pB2 += incBk;
            pB3 += incBk;
            pB4 += incBk;
         }
         *pC0 = rC0_0;
         pC0[1] = rC1_0;
         pC0[2] = rC2_0;
         pC0[3] = rC3_0;
         pC0[4] = rC4_0;
         pC0[5] = rC5_0;
         pC0[6] = rC6_0;
         *pC1 = rC0_1;
         pC1[1] = rC1_1;
         pC1[2] = rC2_1;
         pC1[3] = rC3_1;
         pC1[4] = rC4_1;
         pC1[5] = rC5_1;
         pC1[6] = rC6_1;
         *pC2 = rC0_2;
         pC2[1] = rC1_2;
         pC2[2] = rC2_2;
         pC2[3] = rC3_2;
         pC2[4] = rC4_2;
         pC2[5] = rC5_2;
         pC2[6] = rC6_2;
         *pC3 = rC0_3;
         pC3[1] = rC1_3;
         pC3[2] = rC2_3;
         pC3[3] = rC3_3;
         pC3[4] = rC4_3;
         pC3[5] = rC5_3;
         pC3[6] = rC6_3;
         *pC4 = rC0_4;
         pC4[1] = rC1_4;
         pC4[2] = rC2_4;
         pC4[3] = rC3_4;
         pC4[4] = rC4_4;
         pC4[5] = rC5_4;
         pC4[6] = rC6_4;
         pC0 += incCm;
         pC1 += incCm;
         pC2 += incCm;
         pC3 += incCm;
         pC4 += incCm;
         pA0 += incAm;
         pA1 += incAm;
         pA2 += incAm;
         pA3 += incAm;
         pA4 += incAm;
         pA5 += incAm;
         pA6 += incAm;
         pB0 += incBm;
         pB1 += incBm;
         pB2 += incBm;
         pB3 += incBm;
         pB4 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pC1 += incCn;
      pC2 += incCn;
      pC3 += incCn;
      pC4 += incCn;
      pA0 += incAn;
      pA1 += incAn;
      pA2 += incAn;
      pA3 += incAn;
      pA4 += incAn;
      pA5 += incAn;
      pA6 += incAn;
      pB0 += incBn;
      pB1 += incBn;
      pB2 += incBn;
      pB3 += incBn;
      pB4 += incBn;
   }
   while(pB0 != stN);
   ATL_dJIK48x3x48TN7x3x1_a1_b0(48, 3, 48, alpha, ca, lda, cb + (45*(ldb)), ldb, beta, cc + (45*(ldc)), ldc);
   ATL_dJIK6x45x48TN6x5x1_a1_b0(6, 45, 48, alpha, ca + (42*(lda)), lda, cb, ldb, beta, cc + 42, ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
